part of xfxbase;

// import 'package:flutter/material.dart';
// import 'XfxMenu.dart';
// import 'package:xwidgetsbase/XStylesBase.dart';

class XApp<T, K, U> {
  String app_Name;
  String app_Version;
  String app_FontFamily;
  Color? app_MainColor;
  double app_KforScale = 1;

  ///NON USARLA , usare KforScale
  double _app_KforScale = 1;
  double get KforScale => _app_KforScale;
  set KforScale(v) => XStyles.KforScale = _app_KforScale = v;

  String api_URL;
  String? blob_ConnString_XUpdater;
  String? blob_ConnString_ToSave;
  String? blob_nameAPP;
  List<XMenuGroup> liXMenus = List<XMenuGroup>.empty(growable: true);
  late Widget Function(XMenuItem) getWidget_FormMenuItem;

  T? appState;
  K appServices;
  U appDataService;
  Isolate? dataSendBackThread;
  SendPort? dataSendBackSendMsgPort;

  late PackageInfo packageInfo;
  bool darkTheme;
  bool authentication;

  XApp({
    required this.packageInfo,
    required this.appServices,
    required this.appDataService,
    this.appState,
    this.dataSendBackThread,
    this.dataSendBackSendMsgPort,
    this.app_Name = "",
    this.app_Version = "",
    this.app_FontFamily = "",
    this.app_MainColor,
    this.app_KforScale = 1,
    this.api_URL = "",
    this.blob_ConnString_XUpdater = "",
    this.blob_ConnString_ToSave = "",
    this.blob_nameAPP = "",
    this.darkTheme = true,
    this.authentication = true,
  }) {
    KforScale = app_KforScale;
    app_Version = packageInfo.version;
    blob_nameAPP = packageInfo.appName.toLowerCase();
    XStyles.googleFontFamily = app_FontFamily;
    if (blob_ConnString_ToSave != null && blob_ConnString_ToSave != "") {
      azureStorage = XAzureStorage.parse(blob_ConnString_ToSave ?? "");
    }

    loadPath();
    XColors.done = Color.fromARGB(255, 36, 136, 39);
    XUtils.widthMin_Layout = 800;
    XfxMenu.menuItem_WidthDefault = 300;
  }

  loadPath() async {
    var p = Directory('/storage/emulated/0/Download/${app_Name.replaceAll(" ", "")}'); //await getExternalStorageDirectories(type: StorageDirectory.downloads);
    if (p.existsSync()) {
      XLibStorage.filePath = p.path;
    } else {
      final Directory _appDirNewFolder = await p.create(recursive: true);
      XLibStorage.filePath = _appDirNewFolder.path;
    }
  }
}
