part of xfxbase;

// import 'package:collection/collection.dart';
// import 'package:flutter/material.dart';
// import 'package:provider/provider.dart';
// import 'package:shared_preferences/shared_preferences.dart';
// import 'package:xtoolspackage/xtoolspackage.dart';
// import 'package:xwidgetsbase/XStylesBase.dart';

// import 'package:xwidgetsbase/xWidgetsBase.dart';

class XMainPage_Base<T> extends StatefulWidget {
  XMainPage_Base(this.appState, this.xAppUI, {Key? key, this.title, this.logOUT_Active = true}) : super(key: key);
  String? title;
  bool? logOUT_Active;
  late XAppDataBase appState;
  late XApp xAppUI;

  @override
  XMainPage_BaseState<T> createState() => XMainPage_BaseState<T>();
}

class XMainPage_BaseState<T> extends State<XMainPage_Base<T>> with TickerProviderStateMixin {
  GlobalKey<ScaffoldState> scaffoldKey = GlobalKey<ScaffoldState>();
  late TabController? tabController;
  bool menuPinned = true;
  @override
  void initState() {
    tabController = getTabController();

    super.initState();
  }

  TabController getTabController() {
    return TabController(length: widget.appState.li_XAree.length, vsync: this);
  }

  updateTabController() {
//    tabController = TabController(length: widget.li_XAree!.length, vsync: this);
    tabController = TabController(length: widget.appState.li_XAree.length, vsync: this);

    setState(() {
      print(tabController!.index.toString());
      tabController!.index = widget.appState.li_XAree.firstWhere((element) => element.key_Area == widget.appState.area_Active.key_Area).idx_Area;
      print(tabController!.index.toString());
    });
  }

  @override
  void dispose() {
    tabController!.dispose();
    super.dispose();
  }

  signOut() {
    SharedPreferences.getInstance().then((prefs) {
      prefs.clear();
    });
    Navigator.pushNamed(context, widget.appState.PgName_Login);
  }

  Future<bool> warnLogOff(BuildContext context) async {
    var rval = await showDialog<bool>(
        context: context,
        builder: (c) => AlertDialog(
              title: Text('Attenzione', textAlign: TextAlign.center, style: TextStyle(color: Colors.yellow)),
              content: Text('Sei sicuro di disconnetterti?'),
              actions: [
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.green), onPressed: () => Navigator.pop(c, true), child: Text('Si')),
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.red), onPressed: () => Navigator.pop(c, false), child: Text('No')),
              ],
            ));
    return rval ?? false;
  }

  @override
  Widget build(BuildContext context) {
    // return Consumer<T>(builder: (context, appState, _) {
    // menuPinned = (MediaQuery.of(context).size.width > XUtils.widthMin_Layout);

    return _buildPageLayout(context);
    // });
  }

  int lastTabIdx = -1;
  checkActive_Area(XMenuItem item) {
    var x = widget.appState.li_XAree.firstWhereOrNull((element) => element.key_Area == item.key);
    if (x != null) {
      widget.appState.area_Active = x;
    } else {
      lastTabIdx++;
      var xclArea = XArea(
        item.key,
        lastTabIdx,
        widget.appState.xApp.getWidget_FormMenuItem(item),
        color_Area: item.color_BTN,
        imageIcon_Area: item.image_Icon_BTN,
        label_Area: item.label,
        icon_Area: item.icon_BTN,
        color_AppBar: item.label_Color,
      );

      widget.appState.li_XAree.add(xclArea);
      widget.appState.area_Active = xclArea;
    }
    scaffoldKey.currentState!.closeDrawer();

    setState(() {
      MediaQuery.of(context).size.width < XUtils.widthMin_Layout
          ? (menuPinned = false)
          : menuPinned
              ? (scaffoldKey.currentState!.closeDrawer())
              : (menuPinned = false);
    });
  }

  getWidget_Area(XMenuItem item) {
    return Container();
  }

  Future syncronizeDataFromServer() async {}

  xBuilder_XMenu(Function() tabController, Function() onPinned, bool pinned_Value) {
    return XfxMenu(
      widget.appState.xApp.liXMenus, tabController,
      logOut_Visible: widget.logOUT_Active,
      functOnSync: () => syncronizeDataFromServer(),
      title: widget.title,
      xApp: widget.xAppUI,
      padding: EdgeInsets.symmetric(vertical: 10),
      logOut_OnTap: () async {
        var x = await warnLogOff(context);
        if (x) {
          Navigator.pop(context);
          Navigator.pop(context);
        }
      },
      title_Style: XStyles.xStyTextForLabel(Colors.white),
      menu_BackGroundColor: Colors.grey[900],
      onPressed_PinnedBTN: () {
        if (widget.appState.li_XAree.isEmpty) {
        } else {
          onPinned();
        }
      },
      pinned_Value: pinned_Value,
      onPressed_MenuItem: (i) => checkActive_Area(i),
      // nameApp: Text(sex.app_Name, style: XStyles.xStyTextForLabel()),
    );
  }

  _buildPageLayout(BuildContext context) {
    return WillPopScope(
        ////////////////
        onWillPop: () async {
          scaffoldKey.currentState!.openDrawer();
          return false;
        },
        /////////////////////
        child: Scaffold(
          backgroundColor: Colors.black,
          key: scaffoldKey,
          appBar: null,

          /// X AREA CONTAINER
          body: Container(
              margin: EdgeInsets.only(top: MediaQuery.of(context).size.height < 500 ? 40 : 0),
              child: Row(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  MediaQuery.of(context).size.width < XUtils.widthMin_Layout
                      ? Container()
                      : (menuPinned.not()
                          ? XBtnbase(
                              label: "M\nE\nN\nU",
                              width: 30,
                              decoration: BoxDecoration(color: Colors.grey[800], border: Border.all(color: Colors.white, width: 2)),
                              height: MediaQuery.of(context).size.height,
                              label_Color: Colors.white,
                              onPressed: () {
                                scaffoldKey.currentState!.openDrawer();
                              },
                            )
                          : Container()),
                  menuPinned
                      ? xBuilder_XMenu(updateTabController, () {
                          if (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) {
                            setState(() {
                              menuPinned = false;
                            });
                          } else {
                            setState(() {
                              menuPinned = !menuPinned;
                            });
                          }
                          scaffoldKey.currentState!.closeDrawer();
                        }, menuPinned)
                      : Container(),
                  SizedBox(width: MediaQuery.of(context).size.width < XUtils.widthMin_Layout ? 0 : 10),
                  Expanded(
                      flex: 15,
                      child: (widget.appState.li_XAree.length < 2)
                          ? (widget.appState.li_XAree.isNotEmpty)
                              ? widget.appState.li_XAree.firstWhere((element) => element.key_Area == widget.appState.area_Active.key_Area).widget_Area ?? Container()
                              : Container()
                          : MediaQuery.of(context).size.width < XUtils.widthMin_Layout
                              ? widget.appState.area_Active.widget_Area ?? Container()
                              : XfxArea(
                                  tabController: tabController,
                                  xApp: widget.appState,
                                  margin_Horizontal: 0,
                                  tapOnTab: (idx) {
                                    widget.appState.area_Active = widget.appState.li_XAree.firstWhere((element) => element.idx_Area == idx);
                                  },
                                  tabs_BackGroundColor: Colors.transparent,
                                  title_Visible: false,
                                  bottomBar_Visible: false,
                                  numberOfTabs: widget.appState.li_XAree.length,
                                  isScrollableTabs: false,
                                  children: widget.appState.li_XAree.map((x) {
                                    return x.widget_Area ?? Container();
                                  }).toList(),
                                  tabs: widget.appState.li_XAree
                                      .map((e) => XTabItem(
                                            e.idx_Area,
                                            e.key_Area,
                                            e.label_Area ?? "No Label",
                                            image_Icon: e.imageIcon_Area,
                                            icon: e.icon_Area ?? Icons.warning,
                                            color_backGroundTab: Colors.grey[900],
                                            color_backGroundTab_Activate: e.color_AppBar!.withAlpha(40),
                                            labelColor_Disabled: XColors.foregroundLight,
                                            labelColor_Active: e.color_AppBar,
                                            iconColor_Active: e.color_AppBar,
                                            iconColor_Disabled: XColors.foregroundLight,
                                          ))
                                      .toList(),
                                )),
                ],
              )),
          ///////////////////// MENU

          drawer: menuPinned.not()
              ? xBuilder_XMenu(updateTabController, () {
                  if (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) {
                    setState(() {
                      menuPinned = false;
                    });
                  } else {
                    setState(() {
                      menuPinned = !menuPinned;
                    });
                  }
                  scaffoldKey.currentState!.closeDrawer();
                }, menuPinned)
              : null,
        ));
  }
}
