// TODO Implement this library.
import 'package:flutter/material.dart';
import 'package:syncfusion_flutter_datagrid/datagrid.dart';
import 'package:xtoolspackage/xtoolspackage.dart';

import '../XFDataItem.dart';
import 'XF_XGridDataSource.dart';

header_BoxDecoration({Color? backGroundColor, Color? borderColor}) {
  return BoxDecoration(color: backGroundColor);
}

header_TextStyle({Color? colorText, double? fontSize, TextOverflow? overflow}) {
  return XStyles.xStyleText(colorText: colorText, fontSize: fontSize ?? 18, overflow: overflow);
}

class XCol<T> extends GridColumn {
  late String colKey;
  late String colCaption;
  late double width;
  late double minWidth;
  late double maxWidth;
  late int height;
  int originX;
  int originY = 0;
  int spanX = 0;
  int spanY = 2;
  Type get dataType => T;
  late XProp xmodelXprop;
  late String format;
  late String headerToolTip;
  late int visiblePosition;
  late bool summarize;
  late Alignment labelTxtHAlign;
  late Alignment txtHAlign;
  int resizeStyle;
  int visPos;
  bool hidden;
  bool multilines;
  bool readOnly;
  String toolTip;
  XCol(
    this.colKey,
    this.colCaption,
    this.width,
    this.xmodelXprop, {
    this.height = 0,
    this.visPos = 0,
    this.toolTip = "",
    this.resizeStyle = 0,
    this.format = "",
    this.readOnly = false,
    this.multilines = false,
    this.hidden = false,
    this.minWidth = 15,
    this.maxWidth = 400,
    this.headerToolTip = "",
    this.visiblePosition = 0,
    this.summarize = false,
    this.originX = 0,
    this.originY = 0,
    this.spanX = 0,
    this.spanY = 2,
    this.labelTxtHAlign = Alignment.center,
    this.txtHAlign = Alignment.centerLeft,
  }) : super(columnName: colKey, label: Container());
  XGridColumn getXGCol() {
    return XGridColumn(
        minimumWidth: this.minWidth,
        maximumWidth: this.maximumWidth,
        width: this.width,
        allowEditing: true,
        columnName: this.colKey,
        label: Container(
            child: Stack(children: [
          Container(
              alignment: Alignment.center,
              child: Text(this.colCaption,
                  style: header_TextStyle(
                    colorText: ThemeData.estimateBrightnessForColor(xmodelXprop.col_Color) == Brightness.dark ? Colors.white : xmodelXprop.col_Color,
                  )))
        ])));
  }

  DataGridCell getXDGCell(dynamic val) {
    return DataGridCell(
      columnName: this.colKey,
      value: val,
    );
  }
}

class XGridColumn extends GridColumn {
  XGridColumn({
    required columnName,
    required label,
    columnWidthMode = ColumnWidthMode.none,
    visible = true,
    allowSorting = true,
    autoFitPadding = const EdgeInsets.all(16.0),
    minimumWidth = double.nan,
    maximumWidth = double.nan,
    width = double.nan,
    allowEditing = true,
  }) : super(
          columnName: columnName,
          label: label,
          columnWidthMode: columnWidthMode,
          visible: visible,
          allowSorting: allowSorting,
          autoFitPadding: autoFitPadding,
          minimumWidth: minimumWidth,
          maximumWidth: maximumWidth,
          width: width,
          allowEditing: allowEditing,
        );
}
