part of xsch;

extension BuilderOfPage on XSchedaState {
  Widget xSch_TextFormField_Builder<T>({required BuildContext context, required XCol xCol, required String value, required Function(String)? onChanged, String? hintText, List<TextInputFormatter>? inputFormatters, TextInputType? keyboardType, bool? editable, double? height}) {
    return XTextFormField(
      border: OutlineInputBorder(borderSide: BorderSide(color: XSchedaState.colorOfHintText, width: 1)),
      disabledBorder: OutlineInputBorder(borderSide: BorderSide(color: XSchedaState.colorOfHintText, width: 1)),
      enabledBorder: OutlineInputBorder(borderSide: BorderSide(color: XSchedaState.colorOfHintText, width: 1)),
      label: xCol.colCaption,
      initialValue: xCol.format == "C" ? XUtils.xToCurrency(context, double.parse(value)) : value,
      onChanged: onChanged,
      enabled: editable ?? true,
      height: height,
      multiLines: false,
      maxLines: 1,
      contentPadding: EdgeInsets.only(top: 10, left: 10, bottom: 3, right: 3),
      textStyle: XStyles.xStyTextForDescr(Colors.white),
      labelStyle: XStyles.xStyTextForLabel(XSchedaState.colorOfHintText),
      keyboardType: keyboardType ?? TextInputType.text,
      hintText: hintText ?? "inserisci..",
      inputFormatters: inputFormatters ?? [],
      //TODO devo capire come fare
      // validator:  (value) {
      //         if (activateValidator) {
      //           return validatorBL(value);
      //         } else {
      //           return null;
      //         }
      //       },
    );
  }

  Widget xSch_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(Colors.white),
      label_Style: XStyles.xStyTextForLabel(XSchedaState.colorOfHintText),
    );
  }

  Widget xSch_DateFormField_Builder({required XCol xCol, required DateTime? value, required Function(DateTime)? onDateSelected}) {
    return DateTimeFormField(
        decoration: InputDecoration(
          contentPadding: EdgeInsets.only(top: 4, left: 5, bottom: 4),
          hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.colorOfHintText),
          errorStyle: TextStyle(color: Colors.redAccent),
          border: OutlineInputBorder(borderSide: BorderSide(color: XSchedaState.colorOfHintText, width: 1)),
          enabledBorder: OutlineInputBorder(borderSide: BorderSide(color: XSchedaState.colorOfHintText, width: 1)),
          disabledBorder: OutlineInputBorder(borderSide: BorderSide(color: XSchedaState.colorOfHintText, width: 1)),
          labelText: xCol.colCaption,
          labelStyle: value != null ? XStyles.xStyTextForLabel(XSchedaState.colorOfHintText) : XStyles.xStyTextForDescr(XSchedaState.colorOfHintText),
        ),
        initialValue: value,
        dateFormat: DateFormat("dd/MM/yyyy"),
        dateTextStyle: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
        initialEntryMode: DatePickerEntryMode.input,
        initialDatePickerMode: DatePickerMode.day,
        mode: DateTimeFieldPickerMode.date,
        autovalidateMode: AutovalidateMode.onUserInteraction,
        validator: (e) => (e?.day ?? 0) == 1 ? 'Please not the first day' : null,
        onDateSelected: (value) => onDateSelected!(value));
  }
}
