library xsch;

import 'package:date_field/date_field.dart';
import 'package:flutter/material.dart';
import 'package:collection/collection.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XEnums.dart';

import 'package:xtoolspackage/xtoolspackage.dart';

import '../XFDataItem.dart';
import 'XF_Col.dart';
import 'XF_View.dart';

part '_Xfx_SchComponents.dart';

class XScheda<T extends XFDataItem> extends StatefulWidget {
  //Ci facciamo passare l'oggetto da visualizzare T
  XScheda(
    Key? key,
    this.itemInEdit,
    this.xView, {
    this.title,
    this.title_BackColor,
    this.title_Color,
    this.title_Widgets,
    this.btnOK_label = "OK",
    this.btnCancel_label,
    this.dialogMode_Active = true,
    this.editable = true,
  }) : super(key: key) {
    if (this.title_Widgets == null) {
      this.title_Widgets = [
        XContainerWithLabel(
          title,
          textStyle: XStyles.xStyTextForSubLabel(this.title_Color ?? XColors.foregroundLight),
          color: this.title_BackColor ?? XColors.backGroundTitleContainerForScheda_MAIN,
        ),
      ];
    }
  }
  T itemInEdit;
  final XView xView;
  late List<Widget>? title_Widgets;
  String? btnOK_label;
  String? btnCancel_label;
  String? title;
  Color? title_BackColor;
  Color? title_Color;
  bool dialogMode_Active;
  bool editable;

  @override
  State<XScheda<T>> createState() => XSchedaState<T>();
}

class XSchedaState<T extends XFDataItem> extends State<XScheda<T>> {
  //Propietà della Scheda
  final GlobalKey<FormState> _formkey = GlobalKey();
  late T itemInEdit_Clone;
  bool btnUpdateChangesShow = false;
  @override
  void initState() {
    init_Sch();
    super.initState();
  }

  //Inizializzo la scheda riempendop l'Item Clone per avere possibilità di fare UNDO
  init_Sch() {
    itemInEdit_Clone = widget.itemInEdit.getCloneFull() as T;
  }

  T xcmd_Save() {
    setState(() {
      itemInEdit_Clone.copyProps(itemInEdit_Clone, widget.itemInEdit);
    });
    return widget.itemInEdit;
  }

//quando salvo ciclo per tutte le prop dell'attore e salvo le informazioni

  xOnSubmitted(XCol xCol, dynamic value) async {
    print("onSubmitted oggetto che stop editando: ${itemInEdit_Clone[xCol.colKey]}");
    print("onSubmitted value: ${value}");
    print("onSubmitted key: ${xCol.colKey}");
    itemInEdit_Clone[xCol.colKey] = value!;
    return itemInEdit_Clone[xCol.colKey];
  }

  static double heightOfEntryField = 45;
  static Color colorOfHintText = Colors.grey;

  ///BUILDER DEI WIDGET NON EDITABILI///
  Container xBuilder_CellWidget(XCol xCol, T item, BuildContext context) {
    if (xCol.dataType != DateTime) {
      return Container(
          height: heightOfEntryField,
          width: xCol.width,
          child: xSch_TextFormField_Builder(
            context: context,
            xCol: xCol,
            editable: false,
            hintText: "",
            value: itemInEdit_Clone[xCol.colKey].toString(),
            onChanged: (value) {},
          )
          // xSch_Text__Builder(
          //   context: context,
          //   xCol: xCol,
          //   value: itemInEdit_Clone[xCol.colKey].toString(),
          // )
          );
    } else {
      return Container(
          height: heightOfEntryField,
          width: xCol.width,
          child: xSch_TextFormField_Builder(
            context: context,
            xCol: xCol,
            editable: false,
            hintText: "",
            value: XUtils.dateToString(itemInEdit_Clone[xCol.colKey] != null ? itemInEdit_Clone[xCol.colKey] : DateTime(1900, 01, 01), noDateLabel: ""),
            onChanged: (value) {},
          )
          // xSch_Text__Builder(
          //   context: context,
          //   xCol: xCol,
          //   value:,
          // )
          );
    }
  }

  Widget xBuilder_AdditionalActions(BuildContext context, T item, double heightBTN) {
    return Row(children: [Column(children: [])]);
  }

  ///BUILDER DEI WIDGET EDITABILI///
  Container xBuilder_CellWidget_Editable(XCol xCol, T item, BuildContext context) {
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String) {
      return Container(
          height: heightOfEntryField,
          width: xCol.width,
          child: xSch_TextFormField_Builder(
            context: context,
            xCol: xCol,
            height: heightOfEntryField,
            value: itemInEdit_Clone[xCol.colKey] ?? "",
            onChanged: (value) {
              setState(() => btnUpdateChangesShow = true);
              xOnSubmitted(xCol, value);
            },
          ));
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      return Container(
          height: heightOfEntryField,
          width: xCol.width,
          child: xSch_DateFormField_Builder(
              xCol: xCol,
              value: itemInEdit_Clone[xCol.colKey] == DateTime(1900, 01, 01) ? null : itemInEdit_Clone[xCol.colKey],
              onDateSelected: (value) {
                setState(() {
                  btnUpdateChangesShow = true;
                  xOnSubmitted(xCol, value);
                });
              }));
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      return Container(
          height: heightOfEntryField,
          width: xCol.width,
          child: xSch_TextFormField_Builder(
              context: context,
              xCol: xCol,
              keyboardType: TextInputType.number,
              value: itemInEdit_Clone[xCol.colKey].toString(),
              inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
              onChanged: (value) {
                setState(() => btnUpdateChangesShow = true);
                if (value != "") {
                  xOnSubmitted(xCol, double.parse(value));
                } else {
                  xOnSubmitted(xCol, 0.0);
                }
              }));
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      return Container(
          height: heightOfEntryField,
          width: xCol.width,
          child: xSch_TextFormField_Builder(
            context: context,
            xCol: xCol,
            keyboardType: TextInputType.number,
            value: itemInEdit_Clone[xCol.colKey].toString(),
            inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
            onChanged: (value) {
              setState(() => btnUpdateChangesShow = true);
              if (value != "") {
                xOnSubmitted(xCol, int.parse(value));
              } else {
                xOnSubmitted(xCol, 0);
              }
            },
          ));
    } else {
      //DEVE essere W e H = 0 se no il Wrap fa casino nel gestirlo e va a "un po' a capo" dopo l'ultimo Widget
      return Container(width: 0, height: 0);
    }
  }

  String? validatorBL(dynamic value) {
    if (value == null) return "Fill in please";
    if (value is MapEntry<String, XEnumsDefs>) {
      return null;
    } else if (value is T) {
      {
        return null;
      }
    } else if (value is DateTime) {
      {
        return null;
      }
    } else if (value.isEmpty) {
      return "Fill in please";
    }
  }

  Widget get_TitlwWidget(int originY) {
    var titleIdxFromOriginY = 0;
    if (originY > 0) {
      titleIdxFromOriginY = originY ~/ 2;
      if (titleIdxFromOriginY > widget.title_Widgets!.length - 1) titleIdxFromOriginY = 0;
    }
    return widget.title_Widgets == null ? Container() : widget.title_Widgets![titleIdxFromOriginY];
  }

  Widget xBuilder_WidgetScheda(MapEntry<int, List<XCol<dynamic>>> e, List<Widget> children) {
    return Container(
        margin: EdgeInsets.only(bottom: 10),
        child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [
          get_TitlwWidget(e.key),
          widget.title_Widgets == null ? Container() : SizedBox(height: 15),
          Container(
              margin: EdgeInsets.only(left: 5),
              child: Wrap(
                runSpacing: 10,
                spacing: 10,
                direction: Axis.horizontal,
                alignment: WrapAlignment.start,
                runAlignment: WrapAlignment.start,
                crossAxisAlignment: WrapCrossAlignment.start,
                children: children,
              ))
        ]));
  }

  xBuilder_asContainer() {
    return StatefulBuilder(builder: (BuildContext context, StateSetter setState) {
      // [
      //   XContainerWithLabel(title, textStyle: XStyles.xStyTextForSubLabel(XColors.xcolor_ForegroundDark), height: 25, color: Colors.green[200]!.withAlpha(200)),
      //   // XContainerWithLabel("Specific Information", textStyle: XStyles.xStyTextForSubLabel(XColors.xcolor_ForegroundDark), height: 25, color: Colors.yellow[200]!.withAlpha(200)),
      // ],
      return SingleChildScrollView(
          child: Form(
              key: _formkey,
              child: Container(
                  decoration: BoxDecoration(border: Border.all(width: 3, color: colorOfHintText)),
                  width: MediaQuery.of(context).size.width > 1600 ? MediaQuery.of(context).size.width / 1.2 : MediaQuery.of(context).size.width / 1.2,
                  child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: widget.xView.cols.groupListsBy((element) => element.originY).entries.map(
                        (e) {
                          //x orgni sottoROW/grp
                          return xBuilder_WidgetScheda(
                              e,
                              e.value.map(
                                (e) {
                                  if (widget.editable) {
                                    return xBuilder_CellWidget_Editable(e, itemInEdit_Clone, context);
                                  } else {
                                    return xBuilder_CellWidget(e, itemInEdit_Clone, context);
                                  }
                                },
                              ).toList());
                        },
                      ).toList()))));
    });
  }

  xBuilder_asDialog(double maxRowLen, Widget content) {
    double actionBTN_Heigth = 35;
    return AlertDialog(
        backgroundColor: Colors.grey[900],
        contentPadding: EdgeInsets.symmetric(horizontal: MediaQuery.of(context).size.width * 0.02, vertical: MediaQuery.of(context).size.width * 0.01),
        content: StatefulBuilder(builder: (BuildContext context, StateSetter setState) {
          return SingleChildScrollView(child: Form(key: _formkey, child: Container(decoration: BoxDecoration(border: Border.all(width: 3, color: colorOfHintText)), width: maxRowLen, child: content)));
        }),
        actionsAlignment: MediaQuery.of(context).size.width < 900 ? MainAxisAlignment.center : null,
        actions: [
          Container(
              // height: 35,
              // margin: EdgeInsets.symmetric(horizontal: MediaQuery.of(context).size.width * 0.02),
              child: Wrap(
            runAlignment: WrapAlignment.center,
            alignment: WrapAlignment.center,
            runSpacing: 20,
            spacing: 20,
            children: [
              Container(child: xBuilder_AdditionalActions(context, itemInEdit_Clone, actionBTN_Heigth)), //come  XBtnbase( heightBTN: 35,
              Container(
                  margin: EdgeInsets.only(right: 20),
                  child: Row(crossAxisAlignment: CrossAxisAlignment.center, mainAxisSize: MainAxisSize.min, children: [
                    btnUpdateChangesShow == true
                        ? XBtnbase(
                            height: actionBTN_Heigth,
                            width: MediaQuery.of(context).size.width > 900 ? 180 : 100,
                            elevation: 0,
                            label: widget.btnOK_label,
                            decoration: xBoxDecorationStyleCircular_ForMenu(Colors.greenAccent[400]),
                            onPressed: () {
                              xcmd_Save();
                              Navigator.pop(context, widget.itemInEdit);
                            },
                            label_Style: XStyles.xStyTextForDescr(XColors.foregroundDark))
                        : Container(),
                    SizedBox(width: 10),
                    XBtnbase(
                      width: MediaQuery.of(context).size.width > 800 ? 180 : 100,
                      height: actionBTN_Heigth,
                      elevation: 0,
                      label: widget.btnCancel_label ?? "Cancel",
                      decoration: xBoxDecorationStyleCircular_ForMenu(Colors.redAccent),
                      onPressed: () => Navigator.pop(this.context, null),
                      label_Style: XStyles.xStyTextForDescr(XColors.foregroundDark),
                    ),
                  ]))
            ],
          ))
        ]);
  }

  @override
  Widget build(BuildContext context) {
    var maxRowLen = 0.0;
    var rowLen = 0.0;
    var content = Column(
      mainAxisSize: MainAxisSize.min,
      children: widget.xView.cols.groupListsBy((element) => element.originY).entries.map(
        (e) {
          //x orgni sottoROW/grp
          rowLen = 0;
          var child = xBuilder_WidgetScheda(
            e,
            e.value.map((e) {
              var xwidgt = widget.editable ? xBuilder_CellWidget_Editable(e, itemInEdit_Clone, context) : xBuilder_CellWidget(e, itemInEdit_Clone, context);
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
          );
          if (rowLen > maxRowLen) maxRowLen = rowLen;
          return child;
        },
      ).toList(),
    );
    return widget.dialogMode_Active.not()
        ////Se la scheda non si trova in un dialog
        ? Container(margin: EdgeInsets.all(8), child: xBuilder_asContainer())

        ////Se la scheda si trova in un dialog
        : xBuilder_asDialog(maxRowLen, content);
  }

  xBoxDecorationStyleCircular(Color? color) {
    return BoxDecoration(border: Border.all(color: color ?? Colors.white, width: 1), borderRadius: BorderRadius.circular(20));
  }

  xBoxDecorationStyleCircular_ForMenu(Color? color) {
    return BoxDecoration(color: color, borderRadius: BorderRadius.circular(4));
  }

  XDropSearch<String> xddSearch(String? itemSelected, String label, List<String> liItems, XCol xCol) {
    return XDropSearch<String>(
        label: "${label}".replaceAll("\n", ""),
        itemSelected: itemSelected,
        liItems: liItems,
        al_BackGroundColor: Colors.grey[900],
        itemAsString: (i) => i,
        onChanged_ItemOfDD: (value) {
          itemSelected = value;
          xOnSubmitted(xCol, itemSelected);
          setState(() {
            btnUpdateChangesShow = true;
          });
        });
  }

  XDropSearch<MapEntry<String, XEnumsDefs>> xddSearch_ForMapXEnumsEntry(MapEntry<String, XEnumsDefs>? item, String? itemSelected, String label, List<MapEntry<String, XEnumsDefs>> liItems, XCol xCol) {
    return XDropSearch<MapEntry<String, XEnumsDefs>>(
      label: "${label}".replaceAll("\n", ""),
      itemSelected: item,
      menu_BackGroundColor: Colors.grey[900],
      al_BackGroundColor: Colors.grey[900],
      liItems: liItems,
      itemAsString: (i) => i.value.label,
      onChanged_ItemOfDD: (xEnumsValue) {
        if (xEnumsValue == null) {
          itemSelected = "";
        } else {
          itemSelected = xEnumsValue.key.toString();
        }
        xOnSubmitted(xCol, itemSelected);
        setState(() {
          btnUpdateChangesShow = true;
        });
      },
      dropdownBuilder: (context, item) {
        return item != null ? Row(children: [Expanded(child: Container(child: Text(item.value.label, textAlign: TextAlign.left, overflow: TextOverflow.ellipsis, style: XStyles.xStyTextForTextBase())))]) : Container();
      },
      itemWidgetBuilder: (context, item, isSelected) {
        return Container(height: 35, alignment: Alignment.centerLeft, child: Text(" " + item.value.label, textAlign: TextAlign.left, overflow: TextOverflow.ellipsis));
      },
    );
  }
}
